#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct proizvod
{
	char tip[15];
	char naziv[15];
	int broj;
	int balans;
	struct proizvod *levi,*desni;	
};

#define novi(x) x=(struct proizvod*)malloc(sizeof(struct proizvod))

int dubina(struct proizvod *p)
{
	if(p)
	{
		int dd,dl;
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		
		if(dd>dl) return ++dd;
		else return ++dl;
	}
	return 0;
}

void lrotacija(struct proizvod **t)
{
	struct proizvod *poml,*pomd;
	
	poml=*t;
	pomd=poml->desni;
	
	poml->desni=pomd->levi;
	pomd->levi=poml;
	
	*t=pomd;
	
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
}

void drotacija(struct proizvod **t)
{
	struct proizvod *poml,*pomd;
	
	pomd=*t;
	poml=pomd->levi;
	
	pomd->levi=poml->desni;
	poml->desni=pomd;
	
	*t=poml;
	
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans=dubina(poml->desni) - dubina(poml->levi);	
}

int dodaj(struct proizvod **p, char *tip, char *naziv, int broj)
{
	struct proizvod *t;
	int rezultat=0, inkrement;
	
	t=*p;
	
	if(!t)
	{
		novi(t);
		if(!t)
		{
			printf("Greška pri alokaciji memorije!\n");
			exit(69);
		}
		
		t->balans=0;
		t->broj=broj;
		strcpy(t->tip,tip);
		strcpy(t->naziv,naziv);
		t->levi=NULL;
		t->desni=NULL;
		
		rezultat=1;
	}
	else
	{
		if(strcmp(tip,t->tip)>0) inkrement=dodaj(&(t->desni),tip,naziv,broj);
		else if(strcmp(tip,t->tip)<0) inkrement=-dodaj(&(t->levi),tip,naziv,broj);
		else
		{
			if(strcmp(naziv,t->naziv)>0) inkrement=dodaj(&(t->desni),tip,naziv,broj);
			else inkrement=-dodaj(&(t->levi),tip,naziv,broj);
		}
		
		t->balans+=inkrement;
		
		if(t->balans!=0 && inkrement!=0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

struct proizvod *form()
{
	struct proizvod *p=NULL;
	int i,n,broj;
	char tip[15],naziv[15];
	
	printf("Unesi broj proizvoda: ");
	scanf("%d",&n);

	for(i=0; i<n; i++)
	{
		printf("Unesi tip %d. proizvoda: ",i+1);
		scanf("%s",tip);
		
		printf("Unesi naziv %d. proizvoda: ",i+1);
		scanf("%s",naziv);
		
		printf("Unesi broj komada: ");
		scanf("%d",&broj);
		
		dodaj(&p,tip,naziv,broj);
	}
	
	return p;
}

void ispis(struct proizvod *p)
{
	if(p)
	{
		if(p->levi) ispis(p->levi);
		printf("proizvod %s je tipa %s i ima %d komada\n",p->naziv,p->tip,p->broj);
		if(p->desni) ispis(p->desni);
	}
}

void kolikoIma(struct proizvod *p, char tip, int pp, int *i)
{
	if(p)
	{
		if(p->levi) kolikoIma(p->levi,tip,pp,i);
		if((strcmp(tip,p->tip)==0) && (p->broj < pp)) (*i)++;
		if(p->desni) kolikoIma(p->desni,tip,pp,i);
	}
}

void brisi(struct proizvod **q, struct proizvod *p, char *tip, char *naziv)
{
	if(p)
	{
		if((strcmp(tip,p->tip)!=0) && (strcmp(naziv,p->naziv)!=0)) dodaj(q,p->tip,p->naziv,p->broj);;
		if(p->levi) brisi(q,p->levi,tip,naziv);
		if(p->desni) brisi(q,p->desni,tip,naziv);
	}
}

void proveri(struct proizvod **q, struct proizvod *p, int k, char *tip, char *naziv, int broj)
{
	if(p)
	{
		if((strcmp(p->tip,tip)==0) && (strcmp(p->naziv,naziv)==0)) 
		{
			p->broj-=broj;
			if(p->broj <= 0) brisi(q,p->tip,p->naziv);
			return;
		}
		if(p->levi) proveri(q,p,k,tip,naziv,broj);
		if(p->desni) proveri(q,p,k,tip,naziv,broj);
	}
}

void naruci(struct proizvod **q, struct proizvod *p, int k)
{
	int i,broj;
	char tip[15],naziv[15];
	
	for(i=0; i<k; i++)
	{
		printf("Unesi tip %d. proizvoda: ",i+1);
		scanf("%s",tip);
		
		printf("Unesi naziv %d. proizvoda: ",i+1);
		scanf("%s",naziv);
		
		printf("Unesi broj komada: ");
		scanf("%d",&broj);
		
		proveri(q,p,k,tip,naziv,broj);
	}
}

int main()
{
	struct proizvod *p=NULL,*q=NULL;
	
	p=form();
	ispis(p);
	
	
	int k;
	
	printf("Unesi broj narudžbenica: ");
	scanf("%d",&k);
	
	naruci(&q,p,k);	
	
	
	char tip[15];
	int pp,i=0;
	
	printf("Unesi tip: ");
	scanf("%s",tip);
	
	printf("Unesi broj proizvoda: ");
	scanf("%d",&pp);
	
	//ova funkcija bi trbalo da radi, ali naruči možda ne radi
	kolikoIma(q,tip,pp,&i);
	printf("\nProizvoda tipa %s čiji je broj komada manji od %d ima %d",tip,pp,i);
	
	
	return 42;
}
