#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct st
{
	char *tip;
	char *naziv;
	int broj_komada;
	int balans;
	struct st *levi;
	struct st *desni;
}stablo;

#define aloc(a) a = (stablo*)malloc(sizeof(stablo))
#define alocs(a, s) a = (char*)malloc(strlen(s)+1)

int _print_t(stablo *tree, int is_left, int offset, int depth, char s[20][255])
{
char b[20];
int width = 5,i;

if (!tree) return 0;

sprintf(b, "(%d)",tree->broj_komada);

int left = _print_t(tree->levi, 1, offset, depth + 1, s);
int right = _print_t(tree->desni, 0, offset + left + width, depth + 1, s);

#ifdef COMPACT
for (i = 0; i < width; i++)
s[depth][offset + left + i] = b[i];

if (depth && is_left) {

for (i = 0; i < width + right; i++)
s[depth - 1][offset + left + width/2 + i] = '-';

s[depth - 1][offset + left + width/2] = '.';

} else if (depth && !is_left) {

for (i = 0; i < left + width; i++)
s[depth - 1][offset - width/2 + i] = '-';

s[depth - 1][offset + left + width/2] = '.';
}
#else
for (i = 0; i < width; i++)
s[2 * depth][offset + left + i] = b[i];

if (depth && is_left) {

for (i = 0; i < width + right; i++)
s[2 * depth - 1][offset + left + width/2 + i] = '-';

s[2 * depth - 1][offset + left + width/2] = '+';
s[2 * depth - 1][offset + left + width + right + width/2] = '+';

} else if (depth && !is_left) {

for (i = 0; i < left + width; i++)
s[2 * depth - 1][offset - width/2 + i] = '-';

s[2 * depth - 1][offset + left + width/2] = '+';
s[2 * depth - 1][offset - width/2 - 1] = '+';
}
#endif

return left + width + right;
}

int print_t(stablo *tree)
{
char s[20][255]; int i;
for (i = 0; i < 20; i++)
sprintf(s[i], "%80s", " ");

_print_t(tree, 0, 0, 0, s);

for (i = 0; i < 20; i++)
printf("%s\n", s[i]);
}

void Ispis (stablo *p)
{
	if (p)
	{
		if (p->levi) Ispis(p->levi);
		printf("%s\t%s\t%d\n", p->tip, p->naziv, p->broj_komada);
		if (p->desni) Ispis(p->desni);
	}
}

int Dubina (stablo *p)
{
	int dd = 0, dl = 0;
	
	if (p)
	{
		if (p->levi) dl = Dubina(p->levi);
		if (p->desni) dd = Dubina(p->desni);
		if (dl > dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

void leva_rotacija (stablo **p)
{
	stablo *pomd, *poml;
	
	poml = *p;
	pomd = (*p)->desni;
	poml->desni = pomd->levi;
	pomd = poml->desni;
	*p = pomd;
	
	poml->balans = Dubina(poml->desni) - Dubina(poml->levi);
	pomd->balans = Dubina(pomd->desni) - Dubina(pomd->levi);
}

void desna_rotacija (stablo **p)
{
	stablo *pomd, *poml;
	
	pomd = *p;
	poml = (*p)->levi;
	pomd->levi = poml->desni;
	poml = pomd->levi;
	*p = poml;
	
	poml->balans = Dubina(poml->desni) - Dubina(poml->levi);
	pomd->balans = Dubina(pomd->desni) - Dubina(pomd->levi);
}

int Dodaj (stablo **t, char *tip, char *naziv, int broj)
{
	int inkrement = 0, rezultat = 0;
	stablo *p = *t;

	if (p == NULL)
	{
		aloc(p);
		alocs(p->naziv, naziv);
		alocs(p->tip, tip);
		strcpy(p->naziv, naziv);
		strcpy(p->tip, tip);
		p->balans = 0;
		p->broj_komada = broj;
		p->levi = p->desni = NULL;
		rezultat = 1;
	}
	else
	{
		if (strcmp(p->tip, tip) == 0) 
		{
			if (strcmp(p->naziv, naziv) >= 0) inkrement = Dodaj(&(p->desni), tip, naziv, broj);
			else inkrement = -Dodaj(&(p->levi), tip, naziv, broj);
		}
		else if (strcmp(p->tip, tip) > 0) inkrement = Dodaj(&(p->desni), tip, naziv, broj);
		else inkrement = -Dodaj(&(p->levi), tip, naziv, broj);
		
		p->balans += inkrement;
		
		if (p->balans != 0 && inkrement != 0)
		{
			if (p->balans < -1)
			{
				if (p->levi->balans < 0) desna_rotacija(&p);
				else
				{
					leva_rotacija(&(p->levi));
					desna_rotacija(&p);
				}
			}
			else if (p->balans > 1)
			{
				if (p->desni->balans > 0) leva_rotacija(&p);
				else
				{
					desna_rotacija(&(p->desni));
					leva_rotacija(&p);
				}
			}
			else rezultat = 1;
		}
	}
	
	*t = p;
	return rezultat;
}	
	
stablo* Formiraj (stablo *p, FILE *f)
{
	int n, i, b;
	char naziv[50], tip[50];
	
	fscanf(f, "%d", &n);
	
	for (i = 0; i < n; i++)
	{
		fscanf(f, "%s", tip);
		fscanf(f, "%s", naziv);
		fscanf(f, "%d", &b);
		Dodaj(&p, tip, naziv, b);
	}
		
	fclose(f);	
	return p;
}
	

void Skladiste (stablo *p, char *tip, char *naziv, int broj)
{
	stablo *pom = p;
	
	if (pom)
	{
		if (strcmp(pom->tip, tip) == 0 && strcmp(pom->naziv, naziv) == 0) 
		{
		//	printf("broj = %d\t", pom->broj_komada);
			pom->broj_komada -= broj;
		//	printf("novi broj = %d\n", pom->broj_komada);
			pom = NULL;
		}
		else
		{
			Skladiste(pom->levi, tip, naziv, broj);
			Skladiste(pom->desni, tip, naziv, broj);
		}
		
	}
}			
			
stablo* Narudzbine (stablo *p, FILE *f)
{
	int n, i, b;
	char naziv[50], tip[50];
	
	fscanf(f, "%d", &n);
	
	for (i = 0; i < n; i++)
	{
		fscanf(f, "%s", tip);
		fscanf(f, "%s", naziv);
		fscanf(f, "%d", &b);
		Skladiste(p, tip, naziv, b);
	}	
	
	fclose(f);
	return p;
}

void Novo_Stablo (stablo *p, stablo **q)
{
	if (p)
	{
		if (p->broj_komada != 0) Dodaj(q, p->tip, p->naziv, p->broj_komada);
		Novo_Stablo(p->levi, q);
		Novo_Stablo(p->desni, q);
	}
}

stablo* Pronadji (stablo *p)
{
	while (p->levi) p = p->levi;
	return p;
}

void Sredi (stablo **t)
{
	stablo *p = *t;
	
	if (p)
	{	
		if (p->balans < -1)
		{
			if (p->levi->balans < 0) desna_rotacija(&p);
			else
			{
				leva_rotacija(&(p->levi));
				desna_rotacija(&p);
			}
		}
		else if (p->balans > 1)
		{
			if (p->desni->balans > 0) leva_rotacija(&p);
			else
			{
				desna_rotacija(&(p->desni));
				leva_rotacija(&p);
			}
		}
	}
	
	*t = p;
}

stablo* Obrisi (stablo **t, char *tip, char *naziv)
{
	stablo *p = *t, *pom;
	
	if (p == NULL) return NULL;
	
	if ((strcmp(p->tip, tip) == 0) && (strcmp(p->naziv, naziv) == 0))
	{
		if (!p->levi && !p->desni)
		{
			free(p);
			return NULL;
		}
		if (!p->levi && p->desni)
		{
			pom = p->desni;
			free(p);
			return pom;
		}
		if (p->levi && !p->desni)
		{
			pom = p->levi;
			free(p);
			return pom;
		}
		if (p->levi && p->desni)
		{
			pom = Pronadji(p->desni);
			strcpy(p->tip, pom->tip);
			strcpy(p->naziv, p->naziv);
			p->broj_komada = pom->broj_komada;
			p->desni = Obrisi(&(p->desni), p->tip, p->naziv);
			p->balans = Dubina(p->desni) - Dubina(p->levi);
			Sredi(&p);
			return p;
		}
	}
	else
	{
//	else if (strcmp(p->desni->tip, tip) == 0)
//	{
		p->desni = Obrisi(&(p->desni), tip, naziv);
		p->balans = Dubina(p->desni) - Dubina(p->levi);
		Sredi(&p);
//		return p;
//	}
//	else 
//	{	
		p->levi = Obrisi(&(p->levi), tip, naziv);
		p->balans = Dubina(p->desni) - Dubina(p->levi);
		Sredi(&p);
		return p;
	}
		
}


stablo* Pronadji_Za_Brisanje (stablo *p)
{
	stablo *q;
	
	if (p)
	{
		if (p->broj_komada == 0) return p;
		else 
		{
		//	if (strcmp(p->levi->tip, tip) == 0)
			q = Pronadji_Za_Brisanje(p->levi);
		}
		if (q) return q;
		else return Pronadji_Za_Brisanje(p->desni);
	}
	return NULL;
}	

stablo* Izbaci (stablo *p)
{
	stablo *q = Pronadji_Za_Brisanje(p);
	
	while (q)
	{
		p = Obrisi(&p, q->tip, q->naziv);
		q = Pronadji_Za_Brisanje(p);
	}
}

void Proizvodi_Tipa_T (stablo *p, char *tip, int pp, int *b)
{
	if (p)
	{
		if ((strcmp(p->tip, tip) == 0) && (p->broj_komada < pp)) (*b)++;
		Proizvodi_Tipa_T(p->levi, tip, pp, b);
		Proizvodi_Tipa_T(p->desni, tip, pp, b);
	}	
}

int main (int argc, char *argv[])
{
	FILE *f = fopen(argv[1], "r");
	stablo *p = NULL, *q = NULL;
	char tip[50];
	int pp, b = 0;
	
	p = Formiraj(p, f);
	
	if (p)
	{
		printf("Sadrzaj skladista\n");
		Ispis(p);
		print_t(p);
		f = fopen(argv[2], "r");
		p = Narudzbine(p, f);
		Ispis(p);
	//	printf("Novo \n");
	//	Novo_Stablo(p, &q);
	//	Ispis(q);
		p = Izbaci(p);
		Ispis(p);
		print_t(p);
		
		if (p)
		{
			printf("Unesi T \n");
			scanf("%s", tip);
			printf("Unesi P\n");
			scanf("%d", &pp);
		
			Proizvodi_Tipa_T (p, tip, pp, &b);
			printf("\nProizvoda tipa %s ciji je broj komada manji od %d ima %d\n", tip, pp, b);
		}
		else printf("Stablo je prazno, svi elementi su izbrisani\n");
	}
	else printf("Stablo je prazno\n");
	
	return 0;
}

