/*

Korišćenjem dinamičkih struktura podataka Crveno-Crna(max 20 poena) stabla (Ukoliko se zadatak reši korišćenjem
AVL stabla maksimum je 17 poena.) rešiti sledeći problem:

U skladištu se čuva roba različitog tipa i naziva. Za svaki proizvod se čuva TIP proizvoda (jedna reč), NAZIV proizvoda
(jedna reč), BROJ komada (ceo broj).

Na ulazu se zadaje broj različitih proizvoda N (ceo broj) u skladištu, zatim podaci za svaki proizvod. Proizvodi se
uređuju najpre po TIPu, a proizvodi istog tipa se uređuju po NAZIVu. Ne postoje dva proizvoda sa istim TIPom i
istim NAZIVom.

Nakon unosa svih proizvoda ispisati sadržaj skladišta.

Skladište dobija K narudžbenica (pri čemu proizvodi mogu da se ponavljaju) koje sadrže tip, naziv i broj komada
proizvoda koji naručije. Ukoliko skladište ima dovoljan broj naručenog proizvoda, isporučuje proizvod i ažurira
stanje, ukoliko nema dovoljno isporučuje onoliko koliko ima. Kada broj proizvoda u skladištu postane 0, proizvod
se uklanja iz stabla. (Brisanje bez kreiranja novog stabla donosi bonus od 3 poena. Maksimalan broj poena za ovu
funkciju se dobija samo ako se pri brisanju ne prolazi kroz celo stablo.)



Štampati preostale proizvode iz skladišta.

Odrediti koliko ima različitih proizvoda zadatog tipa T, čiji je broj komada manji od P. Vrednosti T i P se zadaju na
ulazu.

  */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct data
{
    char *tip, *naziv;
    int broj;
};
struct drvo
{
    struct data vrednosti;
    int balans;
    struct drvo *levi, *desni;
};

void l_rotacija(struct drvo **);
void d_rotacija(struct drvo **);
int dodaj(struct drvo **, char *, char *, int);
struct drvo * form();
void pisi(struct drvo *, int);
int dubina(struct drvo *);
void prebroji(struct drvo *, char *, int , int *);
struct data najdi(struct drvo ** );
void umanji(struct drvo *, char *, char *, int );

struct drvo *obrisi(struct drvo *,int *);
void sredi(struct drvo **);







int main(void)
{
    struct drvo *p;
    p = form();

    printf("\n");
    pisi(p,1);
    printf("\n");


    int k;
    printf("unesite K: ");
    scanf("%d",&k);
    char tip[30],naziv[30];
    int broj;

    while(k)
    {
        k--;
        printf("unesite tip: ");
        scanf("%s",tip);
        printf("unesite naziv: ");
        scanf("%s",naziv);
        printf("unesite broj: ");
        scanf("%d",&broj);

        umanji(p,tip,naziv,broj);

    }

    int ind =1;
    while(p!=NULL && ind == 1)
    {
        ind = 0;
        p =obrisi(p,&ind);
    }

    printf("\n azurirano stablo \n\n");
    pisi(p,1);
    printf("\n");


    int P;
    printf("unesite tip: ");
    scanf("%s",tip);
    printf("unesite P: ");
    scanf("%d",&P);

    int n = 0;

    prebroji(p,tip,P,&n);
    printf("Razlicit proizvoda tipa %s  sa brojem manjim od %d ima :%d \n",tip,P,n);


   // printf("Hello World!\n");
    return 0;
}

struct drvo *form()
{
    struct drvo *koren;
    koren = NULL;
    char tip[30], naziv[30];
    int n, broj;

    printf("Unesite n ");
    scanf("%d", &n);

    while(n)
    {
        printf("unesite tip: ");
        scanf("%s",tip);
        printf("unesite naziv: ");
        scanf("%s",naziv);
        printf("unesite broj: ");
        scanf("%d",&broj);

        printf("\n");
        dodaj(&koren,tip, naziv, broj);
        n--;
    }

    return koren;
}

void l_rotacija(struct drvo ** t)
{
    struct drvo *poml, *pomd;

    poml= *t;
    pomd = poml->desni;
    poml->desni = pomd->levi;
    pomd->levi = poml;
    *t = pomd;


    poml->balans = dubina(poml->desni) - dubina(poml->levi);
    pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}


void d_rotacija(struct drvo **t)
{
    struct drvo *poml, *pomd;

    pomd = *t;
    poml = pomd->levi;
    pomd->levi = poml->desni;
    poml->desni = pomd;
    *t = poml;

    poml->balans = dubina(poml->desni) - dubina(poml->levi);
    pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);

}


int dubina(struct drvo *p)
{
    if(p ==  NULL) return 0;

    int a = 1 + dubina(p->levi);
    int b = 1 + dubina(p->desni);

    if(a>b) return a;
    return b;
}

void pisi(struct drvo * p , int i)
{
    if(p == NULL)
        return;
    pisi(p->levi, i+1);
    printf("nivo:%d  %s %s %d \n",i, p->vrednosti.tip, p->vrednosti.naziv, p->vrednosti.broj);
    pisi(p->desni,i+1);
}

int dodaj(struct drvo **koren, char *tip, char *ime, int broj)
{
    struct drvo *t;
    int inkrement, rezultat = 0;

    t = *koren;
    if(t == NULL)
    {
        t = (struct drvo *)malloc(sizeof(struct drvo));
        if(t == NULL)
        {
            printf("Greska pri alokaciji \n");
            exit(0);
        }
        t->vrednosti.tip = (char * )malloc(strlen(tip) + 1);
        strcpy(t->vrednosti.tip, tip);

        t->vrednosti.naziv = (char *)malloc(strlen(ime) + 1);
        strcpy(t->vrednosti.naziv, ime);

        t->vrednosti.broj = broj;
        t->balans = 0;
        t->levi = t->desni =  NULL;

        rezultat = 1;
    }
    else
    {
        if(strcmp(t->vrednosti.tip, tip) == 0 )
        {
            if(strcmp(t->vrednosti.naziv,ime) < 0)
                inkrement = dodaj(&(t->desni),tip, ime, broj);
            else
                inkrement = -dodaj(&(t->levi), tip, ime, broj);
        }
        else
            if(strcmp(t->vrednosti.tip, tip) < 0)
                inkrement = dodaj(&(t->desni),tip, ime, broj);
            else
                inkrement = -dodaj(&(t->levi), tip, ime, broj);

        t->balans +=inkrement;

        if(inkrement!=0 && t->balans != 0)
        {
            if(t->balans< -1)
            {
                if(t->levi ->balans <0) d_rotacija(&t);
                else
                {
                    l_rotacija(&(t->levi));
                    d_rotacija(&t);
                }

            }
            else
                if(t->balans > 1)
                {
                    if(t->desni ->balans > 0) l_rotacija(&t);
                    else
                    {
                        d_rotacija(&(t->desni));
                        l_rotacija(&t);
                    }
                }
                else rezultat = 1;
        }

    }

    *koren = t;
    return rezultat;
}


/*
 * Odrediti koliko ima različitih proizvoda zadatog tipa T, čiji je broj komada manji od P. Vrednosti T i P se zadaju na
ulazu.*/

void prebroji(struct drvo *p, char *tip, int P, int *brojac)
{
    if(p == NULL)
        return;

    if( strcmp(p->vrednosti.tip, tip) == 0  )
    {
        if(p->vrednosti.broj < P)
            (*brojac) ++;

        // ako su istog tipa idi u obe strane
        prebroji(p->levi,tip, P, brojac);
        prebroji(p->desni, tip, P, brojac);
    }
    else
        if(strcmp(p->vrednosti.tip, tip) < 0)
            prebroji(p->desni, tip, P, brojac);
        else
            prebroji(p->levi,tip, P, brojac);
}



void umanji(struct drvo *p, char *tip, char *naziv, int broj)
{
    if(p == NULL)
        return;

    if( strcmp(p->vrednosti.tip, tip) == 0  )
    {
        if(strcmp(p->vrednosti.naziv , naziv) == 0)
        {
            p->vrednosti.broj -= broj;
            return;
        }
        // ako su istog tipa idi u obe strane
        umanji(p->levi,tip, naziv, broj);
        umanji(p->desni, tip, naziv, broj);
    }
    else
        if(strcmp(p->vrednosti.tip, tip) < 0)
            umanji(p->desni, tip, naziv, broj);
        else
            umanji(p->levi,tip,naziv, broj);
}




// brisanje

struct drvo *obrisi(struct drvo *cvor,int *ind)
{
    struct drvo *pom;
    struct data podaci;
    if(cvor == NULL )
        return NULL;


    if(cvor->vrednosti.broj <=0)
    {
        // obrisi ga
        *ind = 1;

        if(cvor->levi == NULL && cvor->desni == NULL)
        {
            free(cvor);
            return NULL;
        }
        if(cvor->levi != NULL && cvor->desni == NULL)
        {
            pom = cvor->levi;
            free(cvor);
            return pom;
        }
        if(cvor->levi ==NULL && cvor->desni !=NULL)
        {
            pom = cvor->desni;
            free(cvor);
            return pom;
        }
        if(cvor->levi != NULL && cvor->desni != NULL)
        {
            podaci = najdi(&(cvor->desni));
            cvor->vrednosti = podaci;
            cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
            sredi(&cvor);
            return cvor;
        }
    }
    else
    {
        cvor->levi = obrisi(cvor->levi,ind);
        cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
        sredi(&cvor);

        cvor->desni = obrisi(cvor->desni,ind);
        cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
        sredi(&cvor);

        return cvor;
    }
}



struct data najdi(struct drvo ** koren)
{
    struct drvo *cvor, *del;
    struct data podaci;
    cvor = *koren;
    if(cvor->levi == NULL)
    {
        del = cvor;
        podaci = cvor->vrednosti;
        cvor = cvor->desni;
        free(del);
    }
    else podaci = najdi(&(cvor->levi));

    if(cvor)
    {
        cvor->balans = dubina(cvor->desni) - dubina(cvor->levi);
        sredi(&cvor);
    }

    *koren = cvor;
    return podaci;
}

void sredi(struct drvo ** koren)
{
    struct drvo *t;
    t = *koren;
    if(t)
    {
        if(t->balans< -1)
        {
            if(t->levi ->balans <0) d_rotacija(&t);
            else
            {
                l_rotacija(&(t->levi));
                d_rotacija(&t);
            }

        }
        else
            if(t->balans > 1)
            {
                if(t->desni ->balans > 0) l_rotacija(&t);
                else
                {
                    d_rotacija(&(t->desni));
                    l_rotacija(&t);
                }
            }

    }

    *koren = t;

}



















































































