#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct st{
    int balans,broj;
    char tip[100],naziv[100];
    struct st *levi,*desni;
}Tdrvo;

#define novi(x) x = (Tdrvo *) malloc(sizeof(Tdrvo));

int _print_t(Tdrvo *tree, int is_left, int offset, int depth, char s[20][255])
{
char b[20];
int width = 5,i;

if (!tree) return 0;

sprintf(b, "(%d)",tree->broj);

int left = _print_t(tree->levi, 1, offset, depth + 1, s);
int right = _print_t(tree->desni, 0, offset + left + width, depth + 1, s);

#ifdef COMPACT
for (i = 0; i < width; i++)
s[depth][offset + left + i] = b[i];

if (depth && is_left) {

for (i = 0; i < width + right; i++)
s[depth - 1][offset + left + width/2 + i] = '-';

s[depth - 1][offset + left + width/2] = '.';

} else if (depth && !is_left) {

for (i = 0; i < left + width; i++)
s[depth - 1][offset - width/2 + i] = '-';

s[depth - 1][offset + left + width/2] = '.';
}
#else
for (i = 0; i < width; i++)
s[2 * depth][offset + left + i] = b[i];

if (depth && is_left) {

for (i = 0; i < width + right; i++)
s[2 * depth - 1][offset + left + width/2 + i] = '-';

s[2 * depth - 1][offset + left + width/2] = '+';
s[2 * depth - 1][offset + left + width + right + width/2] = '+';

} else if (depth && !is_left) {

for (i = 0; i < left + width; i++)
s[2 * depth - 1][offset - width/2 + i] = '-';

s[2 * depth - 1][offset + left + width/2] = '+';
s[2 * depth - 1][offset - width/2 - 1] = '+';
}
#endif

return left + width + right;
}

int print_t(Tdrvo *tree)
{
char s[20][255]; int i;
for (i = 0; i < 20; i++)
sprintf(s[i], "%80s", " ");

_print_t(tree, 0, 0, 0, s);

for (i = 0; i < 20; i++)
printf("%s\n", s[i]);
}

int dubina(Tdrvo *p){
    int dl=0,dd=0;
    if(p){
        if(p->levi) dl=dubina(p->levi);
        if(p->desni) dd=dubina(p->desni);
        if(dl>dd) return ++dl;
        else return ++dd;
    } else return 0;
}

void lrotacija(Tdrvo **p){
    Tdrvo *poml,*pomd;
    poml=*p;
    pomd = poml->desni;
    poml->desni = pomd->levi;
    pomd->levi = poml;
    *p = pomd;
    poml->balans = dubina(poml->desni) - dubina(poml->levi);
    pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(Tdrvo **p){
    Tdrvo *poml,*pomd;
    pomd = *p;
    poml = pomd->levi;
    pomd->levi = poml->desni;
    poml->desni = pomd;
    *p = poml;
    poml->balans = dubina(poml->desni) - dubina(poml->levi);
    pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int dodaj(Tdrvo **p,char *tip,char *naziv,int broj){
    int rezultat = 0,inkrement;
    Tdrvo *t = *p;
    if(!t){
        novi(t);
        t->broj = broj;
        strcpy(t->tip,tip);
        strcpy(t->naziv,naziv);
        t->balans = 0;
        t->levi = t->desni = NULL;
        rezultat = 1;
    } else {
        if(strcmp(tip,t->tip) < 0)
            inkrement = -dodaj(&(t->levi),tip,naziv,broj);
        else if(strcmp(tip,t->tip) > 0)
            inkrement = dodaj(&(t->desni),tip,naziv,broj);
        else {
            if(strcmp(naziv,t->naziv) < 0)
                inkrement = -dodaj(&(t->levi),tip,naziv,broj);
            else
                inkrement = dodaj(&(t->desni),tip,naziv,broj);
        }
        t->balans += inkrement;
        if(inkrement && t->balans){
            if(t->balans < -1){
                if(t->levi->balans < 0)
                    drotacija(&t);
                else {
                    lrotacija(&(t->levi));
                    drotacija(&t);
                }
            } else if(t->balans > 1){
                if(t->desni->balans > 0)
                    lrotacija(&t);
                else {
                    drotacija(&(t->desni));
                    lrotacija(&t);
                }
            } else rezultat = 1;
        }
    }
    *p = t;
    return rezultat;
}

Tdrvo *form(){
    Tdrvo *p=NULL;
    char tip[100],naziv[100];
    int n,broj;
    scanf("%d",&n);
    while(n--){
      //  printf("Unos tipa: ");
        scanf("%s",tip);
      //  printf("Unos naziva: ");
        scanf("%s",naziv);
      //printf("Unos kolicine: ");
        scanf("%d",&broj);
        dodaj(&p,tip,naziv,broj);
    }
    return p;
}

void form_new(Tdrvo *p,Tdrvo **q){
    if(p){
        if(p->levi) form_new(p->levi,q);
        if(p->desni) form_new(p->desni,q);
        if(p->broj)
            dodaj(q,p->tip,p->naziv,p->broj);
    }
}

void naruci(Tdrvo **p,char *tip,char *naziv,int broj,int *ind){
    Tdrvo *t = *p;
    if(t){
        if(!strcmp(tip,t->tip) && !strcmp(naziv,t->naziv))
            if(t->broj < broj){
                t->broj = 0;
                *ind = 1;
            } else
                t->broj = t->broj - broj;
        else {
            if(t->levi) naruci(&(t->levi),tip,naziv,broj,ind);
            if(t->desni) naruci(&(t->desni),tip,naziv,broj,ind);
        }
    }
}

void prebroji(Tdrvo *p,int *br,char *tip,int k){
    if(p){
        if(p->levi) prebroji(p->levi,br,tip,k);
        if(p->desni) prebroji(p->desni,br,tip,k);
        if(!strcmp(p->tip,tip) && p->broj < k)
            ++br;

    }
}

main(){
    Tdrvo *p,*q = NULL;
    p=form();
    print_t(p);
    /*----Unos narudzbenica----*/
    int k,broj,ind;
    char tip[100],naziv[100];
   // printf("uneti broj narudzenica: ");
    scanf("%d",&k);
    while(k--){
        ind = 0;
       // printf("Unos tipa: ");
        scanf("%s",tip);
       // printf("Unos naziva: ");
        scanf("%s",naziv);
       // printf("Unos kolicine: ");
        scanf("%d",&broj);
        naruci(&p,tip,naziv,broj,&ind);
        if(ind){
            form_new(p,&q);
        }
    }
     print_t(q);
      /*----Prebrojavanje----*/
      broj = 0;
      scanf("%s",tip);
      scanf("%d",&k);
      prebroji(p,&broj,tip,k);
      printf("Broj prozivoda tipa %s ima %d\n",tip,broj);
}




























