#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{crvena,crna};

typedef struct drvo{
	char tip[50];
	char naziv[50];
	int broj,boja;
	struct drvo *roditelj,*levi,*desni;
}drvo;

#define aloc(x) x=(drvo*)malloc(sizeof(drvo))

void lrotacija(drvo **t){
	drvo *x,*y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
		else x->roditelj->desni=y;
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija(drvo **t){
	drvo *x,*y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	if(x->desni) x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	if(y->roditelj)
		if(y==y->roditelj->levi) y->roditelj->levi=x;
		else y->roditelj->desni=x;
	x->desni=y;
	y->roditelj=x;
	*t=x;
}

void bojefix(drvo **p,drvo *z){
	drvo *y,*t;
	while((z->roditelj)&&(z->roditelj->boja==crvena)){
		if(z->roditelj==z->roditelj->roditelj->levi){
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja==crvena)){
				z->roditelj->boja=crna;
				y->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				z=z->roditelj->roditelj;
			}
			else{
				if(z==z->roditelj->desni){
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				z->roditelj->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
				
			}
		}
		else{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja==crvena)){
				z->roditelj->boja=crna;
				y->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				z=z->roditelj->roditelj;
			}
			else{
				if(z==z->roditelj->levi){
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=crna;
				z->roditelj->roditelj->boja=crvena;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
	}
	(*p)->boja=crna;
}

void dodaj(drvo **koren,drvo *cvor){
	drvo *x,*y;
	x=*koren;
	y=NULL;
	while(x){
		y=x;
		if(strcmp(cvor->tip,x->tip)<1) x=x->levi;
		else if(strcmp(cvor->tip,x->tip)>1) x=x->desni;
		else{
			if(strcmp(cvor->tip,x->tip)<1) x=x->levi;
			else x=x->desni;
		}
	}
	cvor->roditelj=y;
	if(!y) *koren=cvor;
	else{
		if(strcmp(cvor->tip,y->tip)<1) y->levi=cvor;
		else if(strcmp(cvor->tip,y->tip)>1) y->desni=cvor;
		else{
			if(strcmp(cvor->tip,y->tip)<1) y->levi=cvor;
			else y->desni=cvor;
		}
	}
	bojefix(koren,cvor);
}

struct drvo *form(){
	drvo *koren=NULL,*cvor;
	char tip[50];
	char naziv[50];
	int broj,n,i;
	printf("Unesi n ");
	scanf("%d",&n);
	for (i = 0; i < n; i++)
	{
		aloc(cvor);
		scanf("%s",tip);
		scanf("%s",naziv);
		scanf("%d",&broj);
		cvor->levi=cvor->desni=NULL;
		cvor->boja=crvena;
		strcpy(cvor->tip,tip);
		strcpy(cvor->naziv,naziv);
		cvor->broj=broj;
		dodaj(&koren,cvor);
		//printf("Prosao!\n");
	}
}

void ispis(drvo *koren){
	if(koren){
		ispis(koren->levi);
		printf("%s %s %d\n",koren->tip,koren->naziv,koren->broj);
		if(koren->boja==crvena) printf("(crvena)");
		else printf("(crna)");
		ispis(koren->desni);
	}
}

int main(){
	drvo *koren=NULL;
	koren=form();
	ispis(koren);
	
	return 0;
}























