#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum {CRVENA,CRNA};

struct drvo 
{
	char tip[50];
	char naziv[50];
	int broj,boja;
	struct drvo *roditelj,*levi,*desni;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

void lrotacija(struct drvo **t)
{
	struct drvo *x,*y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	
	if (y->levi)
		y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	
	if (x->roditelj)
		if (x==x->roditelj->levi)
			x->roditelj->levi=y;
		else
			x->roditelj->desni=y;
	
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija(struct drvo **t)
{
	struct drvo *x,*y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	
	if (x->desni)
		x->desni->roditelj=y;
	
	x->roditelj=y->roditelj;
	
	if (y->roditelj)
		if (y==y->roditelj->levi)
			y->roditelj->levi=x;
		else
			y->roditelj->desni=x;
	
	x->desni=y;
	y->roditelj=x;
	*t=x;
}

void bojefix(struct drvo **p,struct drvo *z)
{
	struct drvo *y,*t;
	
	while ((z->roditelj) && (z->roditelj->boja==CRVENA))
	{
		if (z->roditelj==z->roditelj->roditelj->levi)
		{
			y=z->roditelj->roditelj->desni;
			if ((y) && (y->boja==CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if (z==z->roditelj->desni)
				{
					z=z->roditelj;
					lrotacija(&z);
					if (!z->roditelj)
						*p=z;
					z=z->levi;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if (!t->roditelj)
					*p=t;
			}
		}
		else
		{
			y=y->roditelj->roditelj->levi;
			if ((y) && (y->boja==CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if (z==z->roditelj->levi)
				{
					z=z->roditelj;
					drotacija(&z);
					if (!z->roditelj)
						*p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if (!t->roditelj)
					*p=t;
			}
		}
	}
	(*p)->boja=CRNA;
}

void ispis (struct drvo *p)
{
	if (p)
	{
		ispis(p->levi);
		printf("%s,%s,%d-",p->tip,p->naziv,p->broj);
		if (p->boja==CRVENA)
			printf("CRVENA\n");
		else
			printf("CRNA\n");
		ispis(p->desni);
	}
}

void dodaj(struct drvo **p,struct drvo *z)
{
	struct drvo *x,*y;
	x=*p;
	y=NULL;
	
	while (x)
	{
		y=x;
		if (strcmp(z->tip,x->tip) < 0)
			x=x->levi;
		else
		if (strcmp(z->tip,x->tip) > 0)
			x=x->desni;
		else
		{
			if (strcmp(z->naziv,x->naziv) < 0)
				x=x->levi;
			else
				x=x->desni;
		}
	}
	z->roditelj=y;
	if (!y)
		*p=z;
	else
	{
		if (strcmp(z->tip,y->tip) < 0)
			y->levi=z;
		else
		if (strcmp(z->tip,y->tip) > 0)
			y->desni=z;
		else
		{
			if (strcmp(z->naziv,y->naziv) < 0)
				y->levi=z;
			else
				y->desni=z;
		}
	}
	bojefix(p,z);
}	
		
struct drvo *form()
{
	int i,n;
	char s[50],c;
	struct drvo *koren,*cvor;
	koren=NULL;
	
	printf("Unesi broj proizvoda n: ");
	scanf("%d",&n);
	scanf("%c",&c);
	
	for (i=0;i<n;i++)
	{
		novi(cvor);
		
		printf("Unesi tip proizvoda: ");
		gets(s);
		strcpy(cvor->tip,s);
		
		printf("Unesi naziv proizvoda: ");
		gets(s);
		strcpy(cvor->naziv,s);
		
		printf("Unesi broj komada: ");
		scanf("%d",&cvor->broj);
		scanf("%c",&c);
		
		cvor->boja=CRVENA;
		cvor->levi=cvor->desni=NULL;
		dodaj(&koren,cvor);
	}
	return koren;
}

/*void brisi(struct drvo **p,struct drvo *q)
{
	struct drvo *pom;
	
	if (q->broj != 0 )
	{
		novi(pom);
		strcpy(pom->tip,q->tip);
		strcpy(pom->naziv,q->naziv);
		pom->broj=q->broj;
		pom->boja=CRVENA;
		pom->roditelj=NULL;
		pom->levi=pom->desni=NULL;
		dodaj(p,pom);
		if (q->levi)
			brisi(p,q->levi);
		if (q->desni)
			brisi(p,q->desni);
	}
	else
		if (q->levi)
			brisi(p,q->levi);
		if (q->desni)
			brisi(p,q->desni);
	else
		return;
}
*/

void brisi1(struct drvo **p,struct drvo *q)
{
	struct drvo *pom;
	
	if (q)
	if (q->broj != 0 )
	{
		novi(pom);
		strcpy(pom->tip,q->tip);
		strcpy(pom->naziv,q->naziv);
		pom->broj=q->broj;
		pom->boja=CRVENA;
		pom->roditelj=NULL;
		pom->levi=pom->desni=NULL;
		dodaj(p,pom);
		brisi1(p,q->levi);
		brisi1(p,q->desni);
	}
	else
	{
		brisi1(p,q->levi);
		brisi1(p,q->desni);
	}
	else
		return;
}
struct drvo *trazi(struct drvo *p,char t[50],char n[50])
{
	
	if (p)
	{
		if ((!strcmp(p->tip,t)) && (!strcmp(p->naziv,n)))
			return p;
		p=trazi(p->levi,t,n);
		p=trazi(p->desni,t,n);
	}
}

void odredi(struct drvo *p,char t[50],int P,int s)
{
	if (p)
	{
		if ((!strcmp(p->tip,t)) && p->broj < P)
			s=s+1;
		odredi(p->levi,t,P,s);
		odredi(p->desni,t,P,s);
	}
}


main() {
	struct drvo *koren,*pr,*p;
	koren=NULL;
	int i,k,s=0;
	char naziv[50],tip[50],c,t[50];
	int broj,P;
	p=NULL;
	
	koren=form();
	ispis(koren);
	
	printf("Unesi broj porudzbenica: ");
	scanf("%d",&k);
	scanf("%c",&c);
	
	for (i=0;i<k;i++)
	{
		printf("Unesi tip: ");
		gets(tip);
		printf("Unesi naziv: ");
		gets(naziv);
		printf("Unesi broj: ");
		scanf("%d",&broj);
		scanf("%c",&c);
		
		pr=koren;
		koren=trazi(koren,tip,naziv);
		
		koren->broj=koren->broj - broj;
	
		brisi1(&p,koren);
	}	
	
	ispis(pr);
	
	printf("Unesi t: ");
	gets(t);
	
	printf("Unesi P: ");
	scanf("%d",&P);
	scanf("%c",&c);
	
	odredi(pr,t,P,s);
	printf("Postoji takvih: %d\n",s);
}
	
	
	
	
	
	
	
	
